# libtool library helper makefile snippet
# !! libname has to be set prior including this make snippet !!
# !! and libname must not have trailing spaces otherwise errors like:
# debian/scripts/libtool.mk:25: warning: overriding commands for target `"libparagui"'
# debian/scripts/libtool.mk:21: warning: ignoring old commands for target `"libparagui"'
# will be emitted
# also make sure that $(libname)-clean gets invoked _before_ the buildtree is
# removed otherwise files may stay behind.

$(libname)-lt_release=`/bin/ls $(BUILD_TREE)/src/.libs/lib*.so.* | \
 awk '{if (match($$0,/[0-9]+\.[0-9]+\.so\./)) print substr($$0,RSTART,RLENGTH-4)}' | head -1`

$(libname):
	perl debian/scripts/dh_libtoollibs --debname $(libname)

# besides this statement may cause those errors if $(libname) ends with spaces
$(libname)-clean:
	perl debian/scripts/dh_libtoollibs --debname $(libname) --clean

